# frozen_string_literal: true

module ServerComponent
  module Generators
    class InstallGenerator < Rails::Generators::Base
      source_root File.expand_path('../templates', __dir__)

      desc 'Creates a ServerComponent initializer.'

      def create_initializer_file
        template 'server_component.rb', 'config/initializers/server_component.rb'
      end

      def show_readme
        readme 'AFTER_INSTALL' if behavior == :invoke
      end
    end
  end
end
