# frozen_string_literal: true

require 'active_support/dependencies'
require 'jsrb'

module ServerComponent
  autoload :VERSION, 'server_component/version'
  autoload :Base, 'server_component/base'
  autoload :ComponentRouter, 'server_component/component_router'
  autoload :Component, 'server_component/component'

  class NamespaceNotFound < StandardError; end

  mattr_accessor :parent_controller
  @@parent_controller = 'ApplicationController'

  def self.setup
    yield self
  end

  mattr_accessor :mappings
  @@mappings = {}

  mattr_accessor :context_script
  @@context_script = ''

  def self.add_custom_chain(name, function_name)
    Jsrb::ExprChain.add_custom_chain name, function_name
  end
end

require 'server_component/engine'
